<app-loader *ngIf="isLoad"></app-loader>

<div class="py-20">

	<span [matTooltip]=" checkAddRemove ? null : 'Добавление недоступно' ">
		<button mat-flat-button
			*ngIf="!educationProgramForm"
			(click)="addProgram()"
			[disabled]="!checkAddRemove"
			color="primary"
			class="mb-16" >
			<mat-icon svgIcon="plus"></mat-icon>
			Добавить образовательную программу
		</button>
	</span>



	<div class='art-card'>
		<ng-container *ngIf="data; else educationProgramsEmpty">
			<table mat-table
				[dataSource]="data">
				<ng-container matColumnDef="id">
					<th mat-header-cell *matHeaderCellDef > ID </th>
					<td mat-cell *matCellDef="let row"> {{ row.id }}</td>
				</ng-container>
				<ng-container matColumnDef="idAdd">

					<td mat-cell *matCellDef="let row"> </td>
				</ng-container>

				<ng-container matColumnDef="name">
					<th mat-header-cell *matHeaderCellDef > Наименование образовательной программы </th>
					<td mat-cell *matCellDef="let row"> {{ row.name }}</td>
				</ng-container>
				<ng-container matColumnDef="nameAdd">
					<td mat-cell *matCellDef="let row">
						<div>
							<mat-form-field appearance="standard" fxFlex="">
								<mat-label> Наименование образовательной программы</mat-label>
								<input matInput [formControl]="educationProgramForm.get('name')" required>
							</mat-form-field>
						</div>

					</td>
				</ng-container>

				<ng-container matColumnDef="uid">
					<th mat-header-cell *matHeaderCellDef > UID</th>
					<td mat-cell *matCellDef="let row"> {{ row.uid || '-' }}
						<button mat-icon-button
							(click)="editUid(row)"
							matTooltip="Редактировать uid" >
							<mat-icon svgIcon="pencil"></mat-icon>
						</button>
					</td>
				</ng-container>
				<ng-container matColumnDef="uidAdd">
					<td mat-cell *matCellDef="let row">
						<div>
							<mat-form-field appearance="standard" fxFlex="">
								<mat-label> UID</mat-label>
								<input matInput [formControl]="educationProgramForm.get('uid')" appNullValue>
							</mat-form-field>
						</div>
					</td>
				</ng-container>

				<ng-container matColumnDef="actions">
					<th mat-header-cell *matHeaderCellDef ></th>
					<td mat-cell *matCellDef="let row; let index = index;">
						<span [matTooltip]=" checkAddRemove ? null : 'Удаление недоступно' ">
							<button mat-icon-button
								(click)="deleteEducationPrograms(row.id, index)"
								[disabled]="!checkAddRemove"
								matTooltip="Удалить"
								color="accent">
								<mat-icon svgIcon="delete"></mat-icon>
							</button>
						</span>
					</td>
				</ng-container>
				<ng-container matColumnDef="actionsAdd">
					<td mat-cell *matCellDef="let row; let index = index;">
						<div *ngIf="educationProgramForm">
							<button mat-icon-button
								color="primary" class="mr-16" (click)="saveEducationPrograms()"
								matTooltip="Сохранить"
								[disabled]="educationProgramForm.invalid">
								<mat-icon svgIcon="content-save-outline"></mat-icon>
							</button>
							<button mat-icon-button
								color="primary" (click)="cancel()"
								matTooltip="Отменить">
								<mat-icon svgIcon="cancel"></mat-icon>
							</button>
						</div>

					</td>
				</ng-container>
				<ng-container matColumnDef="noRecord">
					<td mat-footer-cell *matFooterCellDef [colSpan]="3" ><i>Образовательные программы не найдены</i></td>
				</ng-container>

				<tr mat-header-row *matHeaderRowDef="['id', 'name', 'uid', 'actions']; sticky: false"></tr>
				<tr  mat-row *matRowDef="let item; columns: ['id', 'name', 'uid', 'actions']; when: !isAddProgram"></tr>
				<tr  mat-row *matRowDef="let item; columns: ['nameAdd', 'uidAdd', 'actionsAdd']; when: isAddProgram"></tr>
				<tr mat-footer-row *matFooterRowDef="['noRecord']" [hidden]="data?.length !== 0"></tr>

			</table>
		</ng-container>

		<ng-template #educationProgramsEmpty>
			<div>
				<i> образовательные программы не найдены </i>
			</div>
		</ng-template>
	</div>
</div>
